------------------------------------------------------------------------
-- File    : client.e
-- Contents: basic hamster control class
-- Authors : Ilona Bl"umel and Christian Borgelt
-- History : 11.03.1999 file created
------------------------------------------------------------------------
class CLIENT
creation
  make

------------------------------------------------------------------------
-- Global Variables
------------------------------------------------------------------------
feature {NONE}
randgen: MIN_STAND;             -- a random number generator

------------------------------------------------------------------------
-- Methods
------------------------------------------------------------------------
feature {ANY}
make is                         -- create a hamster control object
local
  hamster: HAMSTER;             -- the controlled hamster
do
  !!randgen.make                -- create a random number generator
  !!hamster.make;               -- create the hamster to be controlled
  control(hamster);             -- call the hamster control function
  hamster.delete;               -- delete the hamster (that is, send
end  -- make                    -- a delete message to the server)

------------------------------------------------------------------------

random (range: INTEGER): INTEGER is
do                              -- generate a random number
  randgen.next;                 -- in the range [1..range]
  Result := randgen.last_integer(range);
end  -- random

------------------------------------------------------------------------

control (hamster: HAMSTER) is   -- hamster control function (dummy)
local
  cnt: INTEGER;                 -- number of turns made
do
  from
    cnt := 0;                   -- initialize the counter
  until
    cnt = 50                    -- turn 50 times
  loop
    hamster.turn(hamster.left); -- turn the hamster left
    cnt := cnt +1;              -- count the turn made
  end
end  -- control

------------------------------------------------------------------------
end  -- CLIENT
